/*
 * Copyright (c) 2022, MediaTek Inc. All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#ifndef __PMIC_WRAP_REGS_HMAC__
#define __PMIC_WRAP_REGS_HMAC__

//marco for pmicspi_mst
#define GET_SWRST(x)                 ((x>>0)  & 0x00000001)
#define GET_SPI_CK_DCM_EN(x)         ((x>>9)  & 0x00000001)
#define GET_SPI_CK_DCM_TRANS_PRD(x)  ((x>>10) & 0x000000ff)
#define GET_SPI_DCM_CK_EN(x)         ((x>>11) & 0x00000001)
#define GET_SPI_CK_DCM_FSM(x)        ((x>>13) & 0x00000007)
#define GET_SPI_CK_DCM_TRANS_CNTDN(x)  ((x>>16) & 0x000000ff)
#define GET_SPIWRAP_CK_DCM_EN(x)     ((x>>7)  & 0x00000001)
#define GET_SPIMAN_CK_DCM_EN(x)      ((x>>8)  & 0x00000001)
#define GET_SPICIPHER_CK_DCM_EN(x)   ((x>>9)  & 0x00000001)
#define GET_SPICTRL_CK_DCM_EN(x)     ((x>>10) & 0x00000001)
#define GET_SPIWRAP_BUSY(x)          ((x>>5)  & 0x00000001)
#define GET_SPIMAN_BUSY(x)           ((x>>6)  & 0x00000001)
#define GET_SPICTRL_BUSY(x)          ((x>>7)  & 0x00000001)
#define GET_SPI_BUSY(x)              ((x>>8)  & 0x00000001)
#define GET_PMICSPI_BUSY(x)          ((x>>9)  & 0x00000001)
#define GET_SPIWRAP_EN(x)            ((x>>0)  & 0x00000001)
#define GET_SPIWRAP_SPIMUX_REQ(x)    ((x>>0)  & 0x00000001)
#define GET_SPIWRAP_SPIMUX_WRITE(x)  ((x>>1)  & 0x00000001)
#define GET_SPIWRAP_SPIMUX_PMIC(x)   ((x>>2)  & 0x00000001)
#define GET_SPIWRAP_SPIMUX_OP(x)     ((x>>3)  & 0x0000001f)
#define GET_SPIMUX_SPIWRAP_ALE(x)    ((x>>8)  & 0x00000001)
#define GET_SPIMUX_SPIWRAP_DLE(x)    ((x>>9)  & 0x00000001)
#define GET_SPIWRAP_FSM(x)           ((x>>10) & 0x0000000f)
#define GET_SPIWRAP_SPIMUX_WDATA(x)  ((x>>16) & 0x000000ff)
#define GET_SPIMUX_SPIWRAP_RDATA(x)  ((x>>24) & 0x000000ff)
#define GET_SPIMUX_SPIWRAP_ALE_OUTSTANDINGCNT(x)  ((x>>0)  & 0x00000003)
#define GET_SPIMUX_SPIWRAP_DLE_OUTSTANDINGCNT(x)  ((x>>2)  & 0x00000007)
#define GET_SPIMAN_EN(x)             ((x>>0)  & 0x00000001)
#define GET_SPI_WDATA(x)             ((x>>0)  & 0x000000ff)
#define GET_SPI_OP(x)                ((x>>8)  & 0x0000001f)
#define GET_SPI_W(x)                 ((x>>13) & 0x00000001)
#define GET_SPIMAN_RDATA(x)          ((x>>0)  & 0x000000ff)
#define GET_SPIMAN_VLD_CLR(x)        ((x>>0)  & 0x00000001)
#define GET_SPIMAN_EN(x)             ((x>>0)  & 0x00000001)
#define GET_SPIMAN_FSM(x)            ((x>>1)  & 0x00000007)
#define GET_SPIMAN_REQ(x)            ((x>>4)  & 0x00000001)
#define GET_SPIMAN_SPI_BUSY(x)       ((x>>17) & 0x00000001)
#define GET_SPIMUX_SEL(x)            ((x>>0)  & 0x00000001)
#define GET_SPIMUX_SPICIPHER_REQ(x)  ((x>>0)  & 0x00000001)
#define GET_SPIMUX_SPICIPHER_WRITE(x)  ((x>>1)  & 0x00000001)
#define GET_SPIMUX_SPICIPHER_PMIC(x)  ((x>>2)  & 0x00000001)
#define GET_SPIMUX_SPICIPHER_OP(x)   ((x>>3)  & 0x0000001f)
#define GET_SPICIPHER_SPIMUX_ALE(x)  ((x>>8)  & 0x00000001)
#define GET_SPICIPHER_SPIMUX_DLE(x)  ((x>>9)  & 0x00000001)
#define GET_SPIMUX_SPICIPHER_WDATA(x)  ((x>>16) & 0x000000ff)
#define GET_SPICIPHER_SPIMUX_RDATA(x)  ((x>>24) & 0x000000ff)
#define GET_SPICIPHER_SWRST(x)       ((x>>0)  & 0x00000001)
#define GET_PMIC_0_SPICIPHER_EN(x)   ((x>>1)  & 0x00000001)
#define GET_PMIC_0_SPICIPHER_KEY_SEL(x)  ((x>>2)  & 0x00000003)
#define GET_PMIC_0_SPICIPHER_IV_SEL(x)  ((x>>4)  & 0x00000003)
#define GET_PMIC_0_SPICIPHER_MODE(x)  ((x>>6)  & 0x00000001)
#define GET_PMIC_1_SPICIPHER_EN(x)   ((x>>7)  & 0x00000001)
#define GET_PMIC_1_SPICIPHER_KEY_SEL(x)  ((x>>8)  & 0x00000003)
#define GET_PMIC_1_SPICIPHER_IV_SEL(x)  ((x>>10) & 0x00000003)
#define GET_PMIC_1_SPICIPHER_MODE(x)  ((x>>12) & 0x00000001)
#define GET_PMIC_0_SPICIPHER_RDY(x)  ((x>>0)  & 0x00000001)
#define GET_PMIC_0_SPICIPHER_FIFO_FULL(x)  ((x>>1)  & 0x00000001)
#define GET_PMIC_0_SPICIPHER_FIFO_EMPTY(x)  ((x>>2)  & 0x00000001)
#define GET_PMIC_0_SPICIPHER_FIFO_FREECNT(x)  ((x>>3)  & 0x0000001f)
#define GET_PMIC_0_SPICIPHER_FIFO_FILLCNT(x)  ((x>>8)  & 0x0000001f)
#define GET_PMIC_1_SPICIPHER_RDY(x)  ((x>>13) & 0x00000001)
#define GET_PMIC_1_SPICIPHER_FIFO_FULL(x)  ((x>>14) & 0x00000001)
#define GET_PMIC_1_SPICIPHER_FIFO_EMPTY(x)  ((x>>15) & 0x00000001)
#define GET_PMIC_1_SPICIPHER_FIFO_FREECNT(x)  ((x>>16) & 0x0000001f)
#define GET_PMIC_1_SPICIPHER_FIFO_FILLCNT(x)  ((x>>21) & 0x0000001f)
#define GET_PMIC_0_DIO_EN(x)         ((x>>0)  & 0x00000001)
#define GET_PMIC_1_DIO_EN(x)         ((x>>1)  & 0x00000001)
#define GET_PMIC_0_RDDMY(x)          ((x>>0)  & 0x000000ff)
#define GET_PMIC_1_RDDMY(x)          ((x>>8)  & 0x000000ff)
#define GET_CSLEXT_WRITE_START(x)    ((x>>0)  & 0x000000ff)
#define GET_CSLEXT_WRITE_END(x)      ((x>>8)  & 0x000000ff)
#define GET_CSLEXT_READ_START(x)     ((x>>0)  & 0x000000ff)
#define GET_CSLEXT_READ_END(x)       ((x>>8)  & 0x000000ff)
#define GET_CSHEXT_WRITE_START(x)    ((x>>0)  & 0x000000ff)
#define GET_CSHEXT_WRITE_END(x)      ((x>>8)  & 0x000000ff)
#define GET_CSHEXT_READ_START(x)     ((x>>0)  & 0x000000ff)
#define GET_CSHEXT_READ_END(x)       ((x>>8)  & 0x000000ff)
#define GET_EXT_CK_WRITE(x)          ((x>>0)  & 0x000000ff)
#define GET_EXT_CK_READ(x)           ((x>>0)  & 0x000000ff)
#define GET_PMIC_0_SI_DLY(x)         ((x>>0)  & 0x0000001f)
#define GET_PMIC_0_SI_SAMPLING_CK_POL(x)  ((x>>5)  & 0x00000001)
#define GET_PMIC_0_SI_SAMPLING_CK_DLY(x)  ((x>>6)  & 0x00000007)
#define GET_PMIC_1_SI_DLY(x)         ((x>>9)  & 0x0000001f)
#define GET_PMIC_1_SI_SAMPLING_CK_POL(x)  ((x>>14) & 0x00000001)
#define GET_PMIC_1_SI_SAMPLING_CK_DLY(x)  ((x>>15) & 0x00000007)
#define GET_DUAL_PMIC_SI_SAMPLING_CTRL_EN(x)  ((x>>18) & 0x00000001)
#define GET_PMIC_0_SI_DLY_1(x)       ((x>>0)  & 0x0000001f)
#define GET_PMIC_0_SI_SAMPLING_CK_POL_1(x)  ((x>>5)  & 0x00000001)
#define GET_PMIC_0_SI_SAMPLING_CK_DLY_1(x)  ((x>>6)  & 0x00000007)
#define GET_PMIC_1_SI_DLY_1(x)       ((x>>9)  & 0x0000001f)
#define GET_PMIC_1_SI_SAMPLING_CK_POL_1(x)  ((x>>14) & 0x00000001)
#define GET_PMIC_1_SI_SAMPLING_CK_DLY_1(x)  ((x>>15) & 0x00000007)
#define GET_SI_SAMPLING_CTRL_1_EN(x)  ((x>>18) & 0x00000001)
#define GET_PMIC_0_SI_DLY_2(x)       ((x>>0)  & 0x0000001f)
#define GET_PMIC_0_SI_SAMPLING_CK_POL_2(x)  ((x>>5)  & 0x00000001)
#define GET_PMIC_0_SI_SAMPLING_CK_DLY_2(x)  ((x>>6)  & 0x00000007)
#define GET_PMIC_1_SI_DLY_2(x)       ((x>>9)  & 0x0000001f)
#define GET_PMIC_1_SI_SAMPLING_CK_POL_2(x)  ((x>>14) & 0x00000001)
#define GET_PMIC_1_SI_SAMPLING_CK_DLY_2(x)  ((x>>15) & 0x00000007)
#define GET_SI_SAMPLING_CTRL_2_EN(x)  ((x>>18) & 0x00000001)
#define GET_PMIC_0_SI_DLY_3(x)       ((x>>0)  & 0x0000001f)
#define GET_PMIC_0_SI_SAMPLING_CK_POL_3(x)  ((x>>5)  & 0x00000001)
#define GET_PMIC_0_SI_SAMPLING_CK_DLY_3(x)  ((x>>6)  & 0x00000007)
#define GET_PMIC_1_SI_DLY_3(x)       ((x>>9)  & 0x0000001f)
#define GET_PMIC_1_SI_SAMPLING_CK_POL_3(x)  ((x>>14) & 0x00000001)
#define GET_PMIC_1_SI_SAMPLING_CK_DLY_3(x)  ((x>>15) & 0x00000007)
#define GET_SI_SAMPLING_CTRL_3_EN(x)  ((x>>18) & 0x00000001)
#define GET_PMIC_0_SI_DLY_ULPOSC(x)  ((x>>0)  & 0x0000001f)
#define GET_PMIC_0_SI_SAMPLING_CK_POL_ULPOSC(x)  ((x>>5)  & 0x00000001)
#define GET_PMIC_0_SI_SAMPLING_CK_DLY_ULPOSC(x)  ((x>>6)  & 0x00000007)
#define GET_PMIC_1_SI_DLY_ULPOSC(x)  ((x>>9)  & 0x0000001f)
#define GET_PMIC_1_SI_SAMPLING_CK_POL_ULPOSC(x)  ((x>>14) & 0x00000001)
#define GET_PMIC_1_SI_SAMPLING_CK_DLY_ULPOSC(x)  ((x>>15) & 0x00000007)
#define GET_SI_SAMPLING_CTRL_ULPOSC_EN(x)  ((x>>18) & 0x00000001)
#define GET_DEBUG_BANK_0(x)          ((x>>0)  & 0x00000003)
#define GET_DEBUG_BANK_1(x)          ((x>>2)  & 0x00000003)
#define GET_DEBUG_BANK_2(x)          ((x>>4)  & 0x00000003)
#define GET_DEBUG_BANK_3(x)          ((x>>6)  & 0x00000003)
#define GET_RESERVED_0(x)            ((x>>0)  & 0xffffffff)
#define GET_RESERVED_1(x)            ((x>>0)  & 0xffffffff)

//marco for pmif
#define GET_INIT_DONE(x)             ((x>>0)  & 0x00000001)
#define GET_SWRST(x)                 ((x>>0)  & 0x00000001)
#define GET_SYS_CK_DCM_EN(x)         ((x>>0)  & 0x00000001)
#define GET_SYS_CK_DCM_TRANS_PRD(x)  ((x>>1)  & 0x000000ff)
#define GET_SYS_DCM_CK_EN(x)         ((x>>0)  & 0x00000001)
#define GET_SYS_CK_DCM_FSM(x)        ((x>>1)  & 0x00000007)
#define GET_SYS_CK_DCM_TRANS_CNTDN(x)  ((x>>4)  & 0x000000ff)
#define GET_INF_CK_DCM_EN(x)         ((x>>0)  & 0xffffffff)
#define GET_STAUPD_CK_DCM_EN(x)      ((x>>0)  & 0x00000001)
#define GET_ARBITER_CK_DCM_EN(x)     ((x>>1)  & 0x00000001)
#define GET_MONITOR_CK_DCM_EN(x)     ((x>>2)  & 0x00000001)
#define GET_CRC_CK_DCM_EN(x)         ((x>>3)  & 0x00000001)
#define GET_CMDISSUE_CK_DCM_EN(x)    ((x>>4)  & 0x00000001)
#define GET_IRQCTRL_CK_DCM_EN(x)     ((x>>5)  & 0x00000001)
#define GET_WDTCTRL_CK_DCM_EN(x)     ((x>>6)  & 0x00000001)
#define GET_INF_BUSY(x)              ((x>>0)  & 0xffffffff)
#define GET_STAUPD_BUSY(x)           ((x>>0)  & 0x00000001)
#define GET_CHAN_BUSY(x)             ((x>>1)  & 0x00000001)
#define GET_CMDISSUE_BUSY(x)         ((x>>2)  & 0x00000001)
#define GET_SYS_BUSY_NO_PSEL(x)      ((x>>3)  & 0x00000001)
#define GET_SYS_BUSY(x)              ((x>>4)  & 0x00000001)
#define GET_OUTSTANDING_CMD(x)       ((x>>11) & 0x00000001)
#define GET_PMIF_BUSY(x)             ((x>>12) & 0x00000001)
#define GET_DCXOINF0_BUSY(x)         ((x>>0)  & 0x00000001)
#define GET_DCXOINF1_BUSY(x)         ((x>>1)  & 0x00000001)
#define GET_MDADCINF0_BUSY(x)        ((x>>2)  & 0x00000001)
#define GET_MDADCINF1_BUSY(x)        ((x>>3)  & 0x00000001)
#define GET_INTGPSADCINF0_BUSY(x)    ((x>>4)  & 0x00000001)
#define GET_INTGPSADCINF1_BUSY(x)    ((x>>5)  & 0x00000001)
#define GET_EXTGPSADCINF_BUSY(x)     ((x>>6)  & 0x00000001)
#define GET_INF_EN(x)                ((x>>0)  & 0xffffffff)
#define GET_DCXOINF0_EN(x)           ((x>>0)  & 0x00000001)
#define GET_DCXOINF1_EN(x)           ((x>>1)  & 0x00000001)
#define GET_MDADCINF0_EN(x)          ((x>>2)  & 0x00000001)
#define GET_MDADCINF1_EN(x)          ((x>>3)  & 0x00000001)
#define GET_INTGPSADCINF0_EN(x)      ((x>>4)  & 0x00000001)
#define GET_INTGPSADCINF1_EN(x)      ((x>>5)  & 0x00000001)
#define GET_STAUPD_PRD(x)            ((x>>0)  & 0x0000000f)
#define GET_STAUPD_ITEM_EN(x)        ((x>>4)  & 0x000001ff)
#define GET_STAUPD_MAN_TRIG(x)       ((x>>0)  & 0x00000001)
#define GET_STAUPD_TRIG(x)           ((x>>0)  & 0x00000001)
#define GET_STAUPD_DATA_VLD(x)       ((x>>1)  & 0x000001ff)
#define GET_STAUPD_REQ(x)            ((x>>10) & 0x00000001)
#define GET_STAUPD_FSM(x)            ((x>>12) & 0x00000007)
#define GET_STAUPD_DATA(x)           ((x>>16) & 0x0000ffff)
#define GET_STAUPD_ALE_CNT_FULL(x)   ((x>>0)  & 0x00000001)
#define GET_STAUPD_ALE_CNT(x)        ((x>>1)  & 0x0000000f)
#define GET_STAUPD_DLE_CNT_FULL(x)   ((x>>5)  & 0x00000001)
#define GET_STAUPD_DLE_CNT(x)        ((x>>6)  & 0x0000000f)
#define GET_STAUPD_REQ_PENDING(x)    ((x>>10) & 0x000001ff)
#define GET_STAUPD_RDATA_PENDING(x)  ((x>>19) & 0x000001ff)
#define GET_STAUPD_ERR(x)            ((x>>28) & 0x00000001)
#define GET_DCXO_CMD_0_ADDR_0(x)     ((x>>0)  & 0x0000ffff)
#define GET_DCXO_CMD_1_ADDR_0(x)     ((x>>16) & 0x0000ffff)
#define GET_DCXO_CMD_0_WDATA_0(x)    ((x>>0)  & 0x0000ffff)
#define GET_DCXO_CMD_1_WDATA_0(x)    ((x>>16) & 0x0000ffff)
#define GET_DCXO_CMD_0_ADDR_1(x)     ((x>>0)  & 0x0000ffff)
#define GET_DCXO_CMD_1_ADDR_1(x)     ((x>>16) & 0x0000ffff)
#define GET_DCXO_CMD_0_WDATA_1(x)    ((x>>0)  & 0x0000ffff)
#define GET_DCXO_CMD_1_WDATA_1(x)    ((x>>16) & 0x0000ffff)
#define GET_DCXOINF0_DCXO_CTRL(x)    ((x>>0)  & 0x00000001)
#define GET_DCXOINF1_DCXO_CTRL(x)    ((x>>0)  & 0x00000001)
#define GET_MD_AUXADC_MODE_LATCH_SEL_0(x)  ((x>>0)  & 0x00000001)
#define GET_MD_AUXADC_MODE_LATCH_SEL_1(x)  ((x>>1)  & 0x00000001)
#define GET_MD_AUXADC_RDATA_LATEST_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_LATEST_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_WP_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_WP_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_0_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_0_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_1_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_1_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_2_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_2_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_3_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_3_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_4_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_4_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_5_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_5_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_6_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_6_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_7_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_7_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_8_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_8_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_9_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_9_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_10_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_10_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_11_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_11_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_12_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_12_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_13_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_13_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_14_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_14_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_15_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_15_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_16_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_16_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_17_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_17_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_18_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_18_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_19_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_19_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_20_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_20_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_21_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_21_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_22_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_22_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_23_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_23_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_24_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_24_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_25_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_25_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_26_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_26_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_27_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_27_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_28_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_28_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_29_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_29_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_30_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_30_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_31_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MD_AUXADC_RDATA_31_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_MDADCINF0_REQ(x)         ((x>>0)  & 0x00000001)
#define GET_MDADCINF0_ACK(x)         ((x>>1)  & 0x00000001)
#define GET_MDADCINF0_RDATA_VLD(x)   ((x>>2)  & 0x00000001)
#define GET_MDADCINF0_FSM(x)         ((x>>3)  & 0x00000007)
#define GET_MDADCINF0_RDATA(x)       ((x>>16) & 0x0000ffff)
#define GET_MDADCINF0_ALE_CNT_FULL(x)  ((x>>0)  & 0x00000001)
#define GET_MDADCINF0_ALE_CNT(x)     ((x>>1)  & 0x0000003f)
#define GET_MDADCINF0_DLE_CNT_FULL(x)  ((x>>7)  & 0x00000001)
#define GET_MDADCINF0_DLE_CNT_REAL(x)  ((x>>8)  & 0x0000003f)
#define GET_MDADCINF1_REQ(x)         ((x>>0)  & 0x00000001)
#define GET_MDADCINF1_ACK(x)         ((x>>1)  & 0x00000001)
#define GET_MDADCINF1_RDATA_VLD(x)   ((x>>2)  & 0x00000001)
#define GET_MDADCINF1_FSM(x)         ((x>>3)  & 0x00000007)
#define GET_MDADCINF1_RDATA(x)       ((x>>16) & 0x0000ffff)
#define GET_MDADCINF1_ALE_CNT_FULL(x)  ((x>>0)  & 0x00000001)
#define GET_MDADCINF1_ALE_CNT(x)     ((x>>1)  & 0x0000003f)
#define GET_MDADCINF1_DLE_CNT_FULL(x)  ((x>>7)  & 0x00000001)
#define GET_MDADCINF1_DLE_CNT_REAL(x)  ((x>>8)  & 0x0000003f)
#define GET_INT_GPS_AUXADC_CMD_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_INT_GPS_AUXADC_CMD_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_INT_GPS_AUXADC_CMD_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_INT_GPS_AUXADC_CMD_1(x)  ((x>>16) & 0x0000ffff)
#define GET_INT_GPS_AUXADC_RDATA_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_INT_GPS_AUXADC_RDATA_ADDR_1(x)  ((x>>16) & 0x0000ffff)
#define GET_INTGPSADCINF0_REQ(x)     ((x>>0)  & 0x00000001)
#define GET_INTGPSADCINF0_ACK(x)     ((x>>1)  & 0x00000001)
#define GET_INTGPSADCINF0_FSM(x)     ((x>>2)  & 0x00000007)
#define GET_INTGPSADCINF0_AUXADC_DATA_VLD(x)  ((x>>5)  & 0x00000001)
#define GET_INTGPSADCINF0_RDATA(x)   ((x>>16) & 0x00007fff)
#define GET_INTGPSADCINF1_REQ(x)     ((x>>0)  & 0x00000001)
#define GET_INTGPSADCINF1_ACK(x)     ((x>>1)  & 0x00000001)
#define GET_INTGPSADCINF1_FSM(x)     ((x>>2)  & 0x00000007)
#define GET_INTGPSADCINF1_AUXADC_DATA_VLD(x)  ((x>>5)  & 0x00000001)
#define GET_INTGPSADCINF1_RDATA(x)   ((x>>16) & 0x00007fff)
#define GET_EXT_GPS_AUXADC_RDATA_ADDR(x)  ((x>>0)  & 0x0000ffff)
#define GET_EXTGPSADCINF_RDATA(x)    ((x>>0)  & 0x0000ffff)
#define GET_REQCTRL_ARBITER_REQ(x)   ((x>>0)  & 0xffffffff)
#define GET_REQCTRL_ARBITER_WRITE(x)  ((x>>0)  & 0xffffffff)
#define GET_ARBITER_REQCTRL_ALE(x)   ((x>>0)  & 0xffffffff)
#define GET_ARBITER_REQCTRL_DLE(x)   ((x>>0)  & 0xffffffff)
#define GET_ARBITER_REQCTRL_RDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_ARBITER_REQCTRL_RDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_ARBITER_REQCTRL_RDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_ARBITER_REQCTRL_RDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_ARBITER_REQCTRL_ERR(x)   ((x>>0)  & 0x00000001)
#define GET_ARB_EN(x)                ((x>>0)  & 0xffffffff)
#define GET_ARB_MODE(x)              ((x>>0)  & 0x00000001)
#define GET_HIGH_PRIO(x)             ((x>>0)  & 0xffffffff)
#define GET_PRIO_NO_0(x)             ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_1(x)             ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_2(x)             ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_3(x)             ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_4(x)             ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_5(x)             ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_6(x)             ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_7(x)             ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_8(x)             ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_9(x)             ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_10(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_11(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_12(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_13(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_14(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_15(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_16(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_17(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_18(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_19(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_20(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_21(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_22(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_23(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_24(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_25(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_26(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_27(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_28(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_29(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_30(x)            ((x>>0)  & 0x0000001f)
#define GET_PRIO_NO_31(x)            ((x>>0)  & 0x0000001f)
#define GET_LAT_CNTER_EN(x)          ((x>>0)  & 0xffffffff)
#define GET_LAT_LIMIT_LOADING(x)     ((x>>0)  & 0xffffffff)
#define GET_LAT_LIMIT_0(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_1(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_2(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_3(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_4(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_5(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_6(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_7(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_8(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_9(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_10(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_11(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_12(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_13(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_14(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_15(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_16(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_17(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_18(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_19(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_20(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_21(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_22(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_23(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_24(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_25(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_26(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_27(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_28(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_29(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_30(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_31(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_CNTDN_0(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_0(x)   ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_1(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_1(x)   ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_2(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_2(x)   ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_3(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_3(x)   ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_4(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_4(x)   ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_5(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_5(x)   ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_6(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_6(x)   ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_7(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_7(x)   ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_8(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_8(x)   ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_9(x)           ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_9(x)   ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_10(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_10(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_11(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_11(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_12(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_12(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_13(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_13(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_14(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_14(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_15(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_15(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_16(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_16(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_17(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_17(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_18(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_18(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_19(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_19(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_20(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_20(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_21(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_21(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_22(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_22(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_23(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_23(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_24(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_24(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_25(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_25(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_26(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_26(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_27(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_27(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_28(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_28(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_29(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_29(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_30(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_30(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_31(x)          ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_31(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTER_RECORDING_MODE(x)  ((x>>0)  & 0x00000001)
#define GET_LAT_CNTER_RECORDING_STOP_AFTER_INT(x)  ((x>>1)  & 0x00000001)
#define GET_LAT_CNTER_RECORD_CLR(x)  ((x>>0)  & 0xffffffff)
#define GET_LAT_CNTDN_RECORD_0(x)    ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_0(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_1(x)    ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_1(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_2(x)    ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_2(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_3(x)    ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_3(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_4(x)    ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_4(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_5(x)    ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_5(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_6(x)    ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_6(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_7(x)    ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_7(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_8(x)    ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_8(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_9(x)    ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_9(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_10(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_10(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_11(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_11(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_12(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_12(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_13(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_13(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_14(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_14(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_15(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_15(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_16(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_16(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_17(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_17(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_18(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_18(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_19(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_19(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_20(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_20(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_21(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_21(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_22(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_22(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_23(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_23(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_24(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_24(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_25(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_25(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_26(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_26(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_27(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_27(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_28(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_28(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_29(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_29(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_30(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_30(x)  ((x>>16) & 0x00000001)
#define GET_LAT_CNTDN_RECORD_31(x)   ((x>>0)  & 0x000003ff)
#define GET_LAT_LIMIT_REACHED_RECORD_31(x)  ((x>>16) & 0x00000001)
#define GET_LAT_LIMIT_REACHED_INT_EN(x)  ((x>>0)  & 0xffffffff)
#define GET_ARBITER_CMDISSUE_REQ(x)  ((x>>0)  & 0x00000001)
#define GET_ARBITER_CMDISSUE_CMD(x)  ((x>>1)  & 0x00000003)
#define GET_ARBITER_CMDISSUE_WRITE(x)  ((x>>3)  & 0x00000001)
#define GET_ARBITER_CMDISSUE_SLVID(x)  ((x>>4)  & 0x0000000f)
#define GET_ARBITER_CMDISSUE_BYTECNT(x)  ((x>>8)  & 0x0000000f)
#define GET_CMDISSUE_ARBITER_ALE(x)  ((x>>12) & 0x00000001)
#define GET_CMDISSUE_ARBITER_DLE(x)  ((x>>13) & 0x00000001)
#define GET_CMDISSUE_ARBITER_ERR(x)  ((x>>14) & 0x00000001)
#define GET_ARBITER_CMDISSUE_ADDR(x)  ((x>>16) & 0x0000ffff)
#define GET_ARBITER_CMDISSUE_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_ARBITER_CMDISSUE_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_ARBITER_CMDISSUE_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_ARBITER_CMDISSUE_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_CMDISSUE_ARBITER_RDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_CMDISSUE_ARBITER_RDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_CMDISSUE_ARBITER_RDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_CMDISSUE_ARBITER_RDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_WIN_CHAN(x)              ((x>>0)  & 0x0000001f)
#define GET_DLE_CHAN(x)              ((x>>5)  & 0x0000001f)
#define GET_DLE_CHAN_QUEUE_FULL(x)   ((x>>10) & 0x00000001)
#define GET_DLE_CHAN_QUEUE_EMPTY(x)  ((x>>11) & 0x00000001)
#define GET_DLE_CHAN_QUEUE_FREECNT(x)  ((x>>12) & 0x0000000f)
#define GET_DLE_CHAN_QUEUE_FILLCNT(x)  ((x>>16) & 0x0000000f)
#define GET_CRC_EN(x)                ((x>>0)  & 0x00000001)
#define GET_CRC_CAL_ADDR_SEL(x)      ((x>>1)  & 0x00000001)
#define GET_PMIC_0_ACC_QUEUE_FULL(x)  ((x>>0)  & 0x00000001)
#define GET_PMIC_0_ACC_QUEUE_EMPTY(x)  ((x>>1)  & 0x00000001)
#define GET_PMIC_0_ACC_QUEUE_FREECNT(x)  ((x>>2)  & 0x00000007)
#define GET_PMIC_0_ACC_QUEUE_FILLCNT(x)  ((x>>5)  & 0x00000007)
#define GET_PMIC_1_ACC_QUEUE_FULL(x)  ((x>>8)  & 0x00000001)
#define GET_PMIC_1_ACC_QUEUE_EMPTY(x)  ((x>>9)  & 0x00000001)
#define GET_PMIC_1_ACC_QUEUE_FREECNT(x)  ((x>>10) & 0x00000007)
#define GET_PMIC_1_ACC_QUEUE_FILLCNT(x)  ((x>>13) & 0x00000007)
#define GET_DLE_PMIC_QUEUE_FULL(x)   ((x>>16) & 0x00000001)
#define GET_DLE_PMIC_QUEUE_EMPTY(x)  ((x>>17) & 0x00000001)
#define GET_DLE_PMIC_QUEUE_FREECNT(x)  ((x>>18) & 0x00000007)
#define GET_DLE_PMIC_QUEUE_FILLCNT(x)  ((x>>21) & 0x00000007)
#define GET_PMIC_0_SIG_MODE(x)       ((x>>0)  & 0x00000001)
#define GET_PMIC_1_SIG_MODE(x)       ((x>>1)  & 0x00000001)
#define GET_PMIC_0_SIG_ADDR(x)       ((x>>0)  & 0x0000ffff)
#define GET_PMIC_1_SIG_ADDR(x)       ((x>>16) & 0x0000ffff)
#define GET_PMIC_0_SIG_VAL(x)        ((x>>0)  & 0x000000ff)
#define GET_PMIC_1_SIG_VAL(x)        ((x>>8)  & 0x000000ff)
#define GET_PMIC_0_SIG_ERR_VAL(x)    ((x>>0)  & 0x000000ff)
#define GET_PMIC_1_SIG_ERR_VAL(x)    ((x>>8)  & 0x000000ff)
#define GET_PMIC_0_SIG_ERR_VAL_IN_PMIF(x)  ((x>>0)  & 0x000000ff)
#define GET_PMIC_1_SIG_ERR_VAL_IN_PMIF(x)  ((x>>8)  & 0x000000ff)
#define GET_CMDISSUE_EN(x)           ((x>>0)  & 0x00000001)
#define GET_PMIC_CMD_REQ(x)          ((x>>0)  & 0x00000001)
#define GET_PMIC_CMD_CMD(x)          ((x>>1)  & 0x00000003)
#define GET_PMIC_CMD_WRITE(x)        ((x>>3)  & 0x00000001)
#define GET_PMIC_CMD_SLVID(x)        ((x>>4)  & 0x0000000f)
#define GET_PMIC_CMD_BYTECNT(x)      ((x>>8)  & 0x0000000f)
#define GET_PMIC_CMD_RDATA_RDY(x)    ((x>>12) & 0x00000001)
#define GET_PMIC_CMD_ACK(x)          ((x>>13) & 0x00000001)
#define GET_PMIC_CMD_RDATA_VLD(x)    ((x>>14) & 0x00000001)
#define GET_PMIC_CMD_ERR(x)          ((x>>15) & 0x00000001)
#define GET_CMDISSUE_FSM(x)          ((x>>16) & 0x00000001)
#define GET_PMIC_CMD_ADDR(x)         ((x>>0)  & 0x0000ffff)
#define GET_PMIC_CMD_WDATA_31_0(x)   ((x>>0)  & 0xffffffff)
#define GET_PMIC_CMD_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_PMIC_CMD_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_PMIC_CMD_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_PMIC_CMD_RDATA_31_0(x)   ((x>>0)  & 0xffffffff)
#define GET_PMIC_CMD_RDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_PMIC_CMD_RDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_PMIC_CMD_RDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_TIMER_CLK_EN(x)          ((x>>0)  & 0x00000001)
#define GET_TIMER_CLK_AUTO_GATING_EN(x)  ((x>>1)  & 0x00000001)
#define GET_TIMER_CLK_AUTO_GATING_CTRL(x)  ((x>>2)  & 0x00000003)
#define GET_STAUPD_TIMER_RST(x)      ((x>>4)  & 0x00000001)
#define GET_WDT_TIMER_RST(x)         ((x>>5)  & 0x00000001)
#define GET_STAUPD_TIMER(x)          ((x>>0)  & 0x00001fff)
#define GET_WDT_TIMER(x)             ((x>>16) & 0x0000ffff)
#define GET_SPM_SLEEP_REQ_SEL(x)     ((x>>0)  & 0x00000003)
#define GET_VLD_SPM_SLEEP_PROTECTION_CTRL(x)  ((x>>2)  & 0x00000003)
#define GET_SPM_SLEEP_ACK_CONDITION(x)  ((x>>4)  & 0x00000001)
#define GET_SPM_SLEEP_ACK_AFTER_TIMER_CLK_GATED(x)  ((x>>5)  & 0x00000001)
#define GET_SPM_SLEEP_ACK_ON_SCP_SLEEP_GATING(x)  ((x>>6)  & 0x00000001)
#define GET_SPM_SLEEP_ACK_ON_SPI_EINT_MODE_GATING(x)  ((x>>7)  & 0x00000001)
#define GET_SPM_SLEEP_GATING_CONDITION(x)  ((x>>8)  & 0x00000001)
#define GET_SCP_SLEEP_REQ_SEL(x)     ((x>>9)  & 0x00000003)
#define GET_VLD_SCP_SLEEP_PROTECTION_CTRL(x)  ((x>>11) & 0x00000003)
#define GET_SCP_SLEEP_ACK_CONDITION(x)  ((x>>13) & 0x00000001)
#define GET_SCP_SLEEP_ACK_AFTER_TIMER_CLK_GATED(x)  ((x>>14) & 0x00000001)
#define GET_SCP_SLEEP_ACK_ON_SPM_SLEEP_GATING(x)  ((x>>15) & 0x00000001)
#define GET_SCP_SLEEP_ACK_ON_SPI_EINT_MODE_GATING(x)  ((x>>16) & 0x00000001)
#define GET_SCP_SLEEP_GATING_CONDITION(x)  ((x>>17) & 0x00000001)
#define GET_SPM_SLEEP_GATING_EN(x)   ((x>>0)  & 0xffffffff)
#define GET_SCP_SLEEP_GATING_EN(x)   ((x>>0)  & 0xffffffff)
#define GET_SPM_SLEEP_REQ(x)         ((x>>0)  & 0x00000001)
#define GET_SPM_SLEEP_ACK(x)         ((x>>1)  & 0x00000001)
#define GET_SCP_SLEEP_REQ(x)         ((x>>0)  & 0x00000001)
#define GET_SCP_SLEEP_ACK(x)         ((x>>1)  & 0x00000001)
#define GET_PMIC_EINT_REQ(x)         ((x>>0)  & 0x00000001)
#define GET_PMIC_EINT_ACK(x)         ((x>>1)  & 0x00000001)
#define GET_PMIF_RDY_LOW_CONDITION(x)  ((x>>2)  & 0x00000001)
#define GET_PMIF_RDY_LOW_AFTER_TIMER_CLK_GATED(x)  ((x>>3)  & 0x00000001)
#define GET_PMIF_RDY_LOW_ON_SPM_SLEEP_GATING(x)  ((x>>4)  & 0x00000001)
#define GET_PMIF_RDY_LOW_ON_SCP_SLEEP_GATING(x)  ((x>>5)  & 0x00000001)
#define GET_PMIF_RDY_LOW_ON_SPI_EINT_MODE_GATING(x)  ((x>>6)  & 0x00000001)
#define GET_VLD_SRCLK_EN_CTRL(x)     ((x>>7)  & 0x00000001)
#define GET_VLD_SRVOL_EN_CTRL(x)     ((x>>8)  & 0x00000001)
#define GET_SPI_MODE_CTRL(x)         ((x>>9)  & 0x00000003)
#define GET_SPI_MODE_CTRL_PMIF_RDY(x)  ((x>>11) & 0x00000001)
#define GET_SPI_MODE_CTRL_SRCLK_EN(x)  ((x>>12) & 0x00000001)
#define GET_SPI_MODE_CTRL_SRVOL_EN(x)  ((x>>13) & 0x00000001)
#define GET_SPI_MODE_CTRL_OUTSTANDING_CMD(x)  ((x>>14) & 0x00000001)
#define GET_SPI_EINT_MODE_GATING_EN(x)  ((x>>15) & 0x00000001)
#define GET_PMIF_VLD(x)              ((x>>0)  & 0x00000001)
#define GET_PMIF_RDY(x)              ((x>>1)  & 0x00000001)
#define GET_SRCLK_EN(x)              ((x>>2)  & 0x00000001)
#define GET_SRVOL_EN(x)              ((x>>3)  & 0x00000001)
#define GET_PMIC_EINT_0_SRC_NORMAL(x)  ((x>>0)  & 0x00000003)
#define GET_PMIC_EINT_0_SRC_SLEEP(x)  ((x>>2)  & 0x00000001)
#define GET_PMIC_EINT_1_SRC_NORMAL(x)  ((x>>3)  & 0x00000003)
#define GET_PMIC_EINT_1_SRC_SLEEP(x)  ((x>>5)  & 0x00000001)
#define GET_PMIC_EINT_SCP_SRC_NORMAL(x)  ((x>>6)  & 0x00000003)
#define GET_PMIC_EINT_SCP_SRC_SLEEP(x)  ((x>>8)  & 0x00000001)
#define GET_PMIC_EINT_ACK_STAUPD_ITEM_NO(x)  ((x>>9)  & 0x0000000f)
#define GET_PMIC_0_EINT_STA_ADDR(x)  ((x>>0)  & 0x0000ffff)
#define GET_PMIC_1_EINT_STA_ADDR(x)  ((x>>16) & 0x0000ffff)
#define GET_PMIC_0_EINT_STA(x)       ((x>>0)  & 0x00000003)
#define GET_PMIC_1_EINT_STA(x)       ((x>>2)  & 0x00000003)
#define GET_PMIC_EINT(x)             ((x>>4)  & 0x00000003)
#define GET_PMIC_0_EINT_CLR(x)       ((x>>0)  & 0x00000003)
#define GET_PMIC_1_EINT_CLR(x)       ((x>>2)  & 0x00000003)
#define GET_IRQ_EVENT_EN_0(x)        ((x>>0)  & 0xffffffff)
#define GET_IRQ_FLAG_RAW_0(x)        ((x>>0)  & 0xffffffff)
#define GET_IRQ_FLAG_0(x)            ((x>>0)  & 0xffffffff)
#define GET_IRQ_CLR_0(x)             ((x>>0)  & 0xffffffff)
#define GET_IRQ_EVENT_EN_1(x)        ((x>>0)  & 0xffffffff)
#define GET_IRQ_FLAG_RAW_1(x)        ((x>>0)  & 0xffffffff)
#define GET_IRQ_FLAG_1(x)            ((x>>0)  & 0xffffffff)
#define GET_IRQ_CLR_1(x)             ((x>>0)  & 0xffffffff)
#define GET_IRQ_EVENT_EN_2(x)        ((x>>0)  & 0xffffffff)
#define GET_IRQ_FLAG_RAW_2(x)        ((x>>0)  & 0xffffffff)
#define GET_IRQ_FLAG_2(x)            ((x>>0)  & 0xffffffff)
#define GET_IRQ_CLR_2(x)             ((x>>0)  & 0xffffffff)
#define GET_IRQ_EVENT_EN_3(x)        ((x>>0)  & 0xffffffff)
#define GET_IRQ_FLAG_RAW_3(x)        ((x>>0)  & 0xffffffff)
#define GET_IRQ_FLAG_3(x)            ((x>>0)  & 0xffffffff)
#define GET_IRQ_CLR_3(x)             ((x>>0)  & 0xffffffff)
#define GET_WDT_UNIT_SEL(x)          ((x>>0)  & 0x0000000f)
#define GET_WDT_PRD(x)               ((x>>4)  & 0x000000ff)
#define GET_WDT_EVENT_EN_0(x)        ((x>>0)  & 0xffffffff)
#define GET_WDT_FLAG_0(x)            ((x>>0)  & 0xffffffff)
#define GET_WDT_EVENT_EN_1(x)        ((x>>0)  & 0xffffffff)
#define GET_WDT_FLAG_1(x)            ((x>>0)  & 0xffffffff)
#define GET_MONITOR_MODE(x)          ((x>>0)  & 0x00000003)
#define GET_MONITOR_TARGET_0_EN(x)   ((x>>2)  & 0x00000001)
#define GET_MONITOR_TARGET_1_EN(x)   ((x>>3)  & 0x00000001)
#define GET_MONITOR_TARGET_2_EN(x)   ((x>>4)  & 0x00000001)
#define GET_MONITOR_TARGET_3_EN(x)   ((x>>5)  & 0x00000001)
#define GET_MONITOR_TARGET_4_EN(x)   ((x>>6)  & 0x00000001)
#define GET_MONITOR_TARGET_5_EN(x)   ((x>>7)  & 0x00000001)
#define GET_MONITOR_TARGET_6_EN(x)   ((x>>8)  & 0x00000001)
#define GET_MONITOR_TARGET_7_EN(x)   ((x>>9)  & 0x00000001)
#define GET_MONITOR_STOP_AFTER_INT(x)  ((x>>10) & 0x00000001)
#define GET_MONITOR_RST(x)           ((x>>11) & 0x00000001)
#define GET_MONITOR_TARGET_CHAN_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_TARGET_CHAN_1(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_TARGET_CHAN_2(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_TARGET_CHAN_3(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_TARGET_CHAN_4(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_TARGET_CHAN_5(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_TARGET_CHAN_6(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_TARGET_CHAN_7(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_TARGET_WRITE_0(x)  ((x>>0)  & 0x00000001)
#define GET_MONITOR_TARGET_WRITE_0_MASK(x)  ((x>>1)  & 0x00000001)
#define GET_MONITOR_TARGET_WRITE_1(x)  ((x>>2)  & 0x00000001)
#define GET_MONITOR_TARGET_WRITE_1_MASK(x)  ((x>>3)  & 0x00000001)
#define GET_MONITOR_TARGET_WRITE_2(x)  ((x>>4)  & 0x00000001)
#define GET_MONITOR_TARGET_WRITE_2_MASK(x)  ((x>>5)  & 0x00000001)
#define GET_MONITOR_TARGET_WRITE_3(x)  ((x>>6)  & 0x00000001)
#define GET_MONITOR_TARGET_WRITE_3_MASK(x)  ((x>>7)  & 0x00000001)
#define GET_MONITOR_TARGET_WRITE_4(x)  ((x>>8)  & 0x00000001)
#define GET_MONITOR_TARGET_WRITE_4_MASK(x)  ((x>>9)  & 0x00000001)
#define GET_MONITOR_TARGET_WRITE_5(x)  ((x>>10) & 0x00000001)
#define GET_MONITOR_TARGET_WRITE_5_MASK(x)  ((x>>11) & 0x00000001)
#define GET_MONITOR_TARGET_WRITE_6(x)  ((x>>12) & 0x00000001)
#define GET_MONITOR_TARGET_WRITE_6_MASK(x)  ((x>>13) & 0x00000001)
#define GET_MONITOR_TARGET_WRITE_7(x)  ((x>>14) & 0x00000001)
#define GET_MONITOR_TARGET_WRITE_7_MASK(x)  ((x>>15) & 0x00000001)
#define GET_MONITOR_TARGET_ADDR_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_TARGET_ADDR_0_MASK(x)  ((x>>16) & 0x0000ffff)
#define GET_MONITOR_TARGET_ADDR_1(x)  ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_TARGET_ADDR_1_MASK(x)  ((x>>16) & 0x0000ffff)
#define GET_MONITOR_TARGET_ADDR_2(x)  ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_TARGET_ADDR_2_MASK(x)  ((x>>16) & 0x0000ffff)
#define GET_MONITOR_TARGET_ADDR_3(x)  ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_TARGET_ADDR_3_MASK(x)  ((x>>16) & 0x0000ffff)
#define GET_MONITOR_TARGET_ADDR_4(x)  ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_TARGET_ADDR_4_MASK(x)  ((x>>16) & 0x0000ffff)
#define GET_MONITOR_TARGET_ADDR_5(x)  ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_TARGET_ADDR_5_MASK(x)  ((x>>16) & 0x0000ffff)
#define GET_MONITOR_TARGET_ADDR_6(x)  ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_TARGET_ADDR_6_MASK(x)  ((x>>16) & 0x0000ffff)
#define GET_MONITOR_TARGET_ADDR_7(x)  ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_TARGET_ADDR_7_MASK(x)  ((x>>16) & 0x0000ffff)
#define GET_MONITOR_TARGET_WDATA_0(x)  ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_TARGET_WDATA_0_MASK(x)  ((x>>16) & 0x0000ffff)
#define GET_MONITOR_TARGET_WDATA_1(x)  ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_TARGET_WDATA_1_MASK(x)  ((x>>16) & 0x0000ffff)
#define GET_MONITOR_TARGET_WDATA_2(x)  ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_TARGET_WDATA_2_MASK(x)  ((x>>16) & 0x0000ffff)
#define GET_MONITOR_TARGET_WDATA_3(x)  ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_TARGET_WDATA_3_MASK(x)  ((x>>16) & 0x0000ffff)
#define GET_MONITOR_TARGET_WDATA_4(x)  ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_TARGET_WDATA_4_MASK(x)  ((x>>16) & 0x0000ffff)
#define GET_MONITOR_TARGET_WDATA_5(x)  ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_TARGET_WDATA_5_MASK(x)  ((x>>16) & 0x0000ffff)
#define GET_MONITOR_TARGET_WDATA_6(x)  ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_TARGET_WDATA_6_MASK(x)  ((x>>16) & 0x0000ffff)
#define GET_MONITOR_TARGET_WDATA_7(x)  ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_TARGET_WDATA_7_MASK(x)  ((x>>16) & 0x0000ffff)
#define GET_MONITOR_RECORD_CNT(x)    ((x>>0)  & 0x0000003f)
#define GET_MONITOR_REC_0_ADDR(x)    ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_0_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_0_SLVID(x)   ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_0_WRITE(x)   ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_0_CMD(x)     ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_0_CHAN(x)    ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_0_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_0_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_0_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_0_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_1_ADDR(x)    ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_1_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_1_SLVID(x)   ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_1_WRITE(x)   ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_1_CMD(x)     ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_1_CHAN(x)    ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_1_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_1_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_1_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_1_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_2_ADDR(x)    ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_2_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_2_SLVID(x)   ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_2_WRITE(x)   ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_2_CMD(x)     ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_2_CHAN(x)    ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_2_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_2_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_2_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_2_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_3_ADDR(x)    ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_3_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_3_SLVID(x)   ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_3_WRITE(x)   ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_3_CMD(x)     ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_3_CHAN(x)    ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_3_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_3_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_3_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_3_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_4_ADDR(x)    ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_4_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_4_SLVID(x)   ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_4_WRITE(x)   ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_4_CMD(x)     ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_4_CHAN(x)    ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_4_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_4_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_4_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_4_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_5_ADDR(x)    ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_5_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_5_SLVID(x)   ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_5_WRITE(x)   ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_5_CMD(x)     ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_5_CHAN(x)    ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_5_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_5_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_5_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_5_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_6_ADDR(x)    ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_6_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_6_SLVID(x)   ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_6_WRITE(x)   ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_6_CMD(x)     ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_6_CHAN(x)    ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_6_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_6_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_6_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_6_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_7_ADDR(x)    ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_7_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_7_SLVID(x)   ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_7_WRITE(x)   ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_7_CMD(x)     ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_7_CHAN(x)    ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_7_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_7_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_7_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_7_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_8_ADDR(x)    ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_8_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_8_SLVID(x)   ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_8_WRITE(x)   ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_8_CMD(x)     ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_8_CHAN(x)    ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_8_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_8_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_8_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_8_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_9_ADDR(x)    ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_9_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_9_SLVID(x)   ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_9_WRITE(x)   ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_9_CMD(x)     ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_9_CHAN(x)    ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_9_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_9_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_9_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_9_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_10_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_10_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_10_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_10_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_10_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_10_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_10_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_10_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_10_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_10_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_11_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_11_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_11_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_11_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_11_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_11_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_11_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_11_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_11_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_11_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_12_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_12_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_12_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_12_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_12_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_12_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_12_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_12_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_12_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_12_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_13_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_13_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_13_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_13_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_13_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_13_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_13_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_13_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_13_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_13_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_14_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_14_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_14_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_14_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_14_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_14_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_14_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_14_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_14_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_14_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_15_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_15_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_15_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_15_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_15_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_15_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_15_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_15_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_15_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_15_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_16_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_16_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_16_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_16_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_16_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_16_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_16_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_16_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_16_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_16_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_17_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_17_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_17_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_17_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_17_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_17_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_17_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_17_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_17_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_17_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_18_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_18_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_18_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_18_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_18_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_18_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_18_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_18_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_18_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_18_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_19_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_19_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_19_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_19_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_19_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_19_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_19_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_19_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_19_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_19_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_20_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_20_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_20_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_20_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_20_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_20_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_20_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_20_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_20_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_20_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_21_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_21_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_21_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_21_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_21_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_21_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_21_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_21_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_21_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_21_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_22_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_22_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_22_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_22_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_22_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_22_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_22_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_22_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_22_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_22_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_23_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_23_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_23_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_23_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_23_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_23_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_23_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_23_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_23_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_23_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_24_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_24_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_24_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_24_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_24_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_24_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_24_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_24_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_24_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_24_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_25_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_25_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_25_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_25_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_25_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_25_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_25_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_25_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_25_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_25_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_26_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_26_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_26_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_26_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_26_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_26_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_26_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_26_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_26_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_26_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_27_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_27_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_27_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_27_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_27_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_27_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_27_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_27_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_27_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_27_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_28_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_28_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_28_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_28_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_28_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_28_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_28_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_28_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_28_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_28_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_29_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_29_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_29_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_29_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_29_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_29_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_29_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_29_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_29_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_29_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_30_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_30_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_30_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_30_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_30_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_30_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_30_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_30_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_30_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_30_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_31_ADDR(x)   ((x>>0)  & 0x0000ffff)
#define GET_MONITOR_REC_31_BYTECNT(x)  ((x>>16) & 0x0000000f)
#define GET_MONITOR_REC_31_SLVID(x)  ((x>>20) & 0x0000000f)
#define GET_MONITOR_REC_31_WRITE(x)  ((x>>24) & 0x00000001)
#define GET_MONITOR_REC_31_CMD(x)    ((x>>25) & 0x00000003)
#define GET_MONITOR_REC_31_CHAN(x)   ((x>>27) & 0x0000001f)
#define GET_MONITOR_REC_31_WDATA_31_0(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_31_WDATA_63_32(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_31_WDATA_95_64(x)  ((x>>0)  & 0xffffffff)
#define GET_MONITOR_REC_31_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_DEBUG_BANK_0(x)          ((x>>0)  & 0x00000003)
#define GET_DEBUG_BANK_1(x)          ((x>>2)  & 0x00000003)
#define GET_DEBUG_BANK_2(x)          ((x>>4)  & 0x00000003)
#define GET_DEBUG_BANK_3(x)          ((x>>6)  & 0x00000003)
#define GET_SYS_BUSY_FOR_SLEEP_ACK_WITHOUT_PSEL(x)  ((x>>0)  & 0x00000001)
#define GET_INT_GPS_AUXADCINF_BUSY_WITHOUT_SPM_SLEEP_REQ(x)  ((x>>1)  & 0x00000001)
#define GET_INT_GPS_AUXADCINF_BUSY_WITHOUT_SCP_SLEEP_REQ(x)  ((x>>2)  & 0x00000001)
#define GET_BWC_OPTIONS_RESERVED(x)  ((x>>3)  & 0x1fffffff)
#define GET_RESERVED_0(x)            ((x>>0)  & 0xffffffff)
#define GET_RESERVED_1(x)            ((x>>0)  & 0xffffffff)
#define GET_SWINF_0_ADDR(x)          ((x>>0)  & 0x0000ffff)
#define GET_SWINF_0_BYTECNT(x)       ((x>>16) & 0x0000000f)
#define GET_SWINF_0_SLVID(x)         ((x>>24) & 0x0000000f)
#define GET_SWINF_0_WRITE(x)         ((x>>29) & 0x00000001)
#define GET_SWINF_0_CMD(x)           ((x>>30) & 0x00000003)
#define GET_SWINF_0_WDATA_31_0(x)    ((x>>0)  & 0xffffffff)
#define GET_SWINF_0_WDATA_63_32(x)   ((x>>0)  & 0xffffffff)
#define GET_SWINF_0_WDATA_95_64(x)   ((x>>0)  & 0xffffffff)
#define GET_SWINF_0_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_SWINF_0_RDATA_31_0(x)    ((x>>0)  & 0xffffffff)
#define GET_SWINF_0_RDATA_63_32(x)   ((x>>0)  & 0xffffffff)
#define GET_SWINF_0_RDATA_95_64(x)   ((x>>0)  & 0xffffffff)
#define GET_SWINF_0_RDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_SWINF_0_VLD_CLR(x)       ((x>>0)  & 0x00000001)
#define GET_SWINF_0_EN(x)            ((x>>0)  & 0x00000001)
#define GET_SWINF_0_FSM(x)           ((x>>1)  & 0x00000007)
#define GET_SWINF_0_REQ(x)           ((x>>4)  & 0x00000001)
#define GET_SWINF_0_QUEUE_FULL(x)    ((x>>5)  & 0x00000001)
#define GET_SWINF_0_QUEUE_EMPTY(x)   ((x>>6)  & 0x00000001)
#define GET_SWINF_0_QUEUE_FREECNT(x)  ((x>>7)  & 0x0000000f)
#define GET_SWINF_0_QUEUE_FILLCNT(x)  ((x>>11) & 0x0000000f)
#define GET_SWINF_0_INIT_DONE(x)     ((x>>15) & 0x00000001)
#define GET_SWINF_0_SYS_BUSY(x)      ((x>>17) & 0x00000001)
#define GET_SWINF_0_ERR(x)           ((x>>18) & 0x00000001)
#define GET_SWINF_1_ADDR(x)          ((x>>0)  & 0x0000ffff)
#define GET_SWINF_1_BYTECNT(x)       ((x>>16) & 0x0000000f)
#define GET_SWINF_1_SLVID(x)         ((x>>24) & 0x0000000f)
#define GET_SWINF_1_WRITE(x)         ((x>>29) & 0x00000001)
#define GET_SWINF_1_CMD(x)           ((x>>30) & 0x00000003)
#define GET_SWINF_1_WDATA_31_0(x)    ((x>>0)  & 0xffffffff)
#define GET_SWINF_1_WDATA_63_32(x)   ((x>>0)  & 0xffffffff)
#define GET_SWINF_1_WDATA_95_64(x)   ((x>>0)  & 0xffffffff)
#define GET_SWINF_1_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_SWINF_1_RDATA_31_0(x)    ((x>>0)  & 0xffffffff)
#define GET_SWINF_1_RDATA_63_32(x)   ((x>>0)  & 0xffffffff)
#define GET_SWINF_1_RDATA_95_64(x)   ((x>>0)  & 0xffffffff)
#define GET_SWINF_1_RDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_SWINF_1_VLD_CLR(x)       ((x>>0)  & 0x00000001)
#define GET_SWINF_1_EN(x)            ((x>>0)  & 0x00000001)
#define GET_SWINF_1_FSM(x)           ((x>>1)  & 0x00000007)
#define GET_SWINF_1_REQ(x)           ((x>>4)  & 0x00000001)
#define GET_SWINF_1_QUEUE_FULL(x)    ((x>>5)  & 0x00000001)
#define GET_SWINF_1_QUEUE_EMPTY(x)   ((x>>6)  & 0x00000001)
#define GET_SWINF_1_QUEUE_FREECNT(x)  ((x>>7)  & 0x0000000f)
#define GET_SWINF_1_QUEUE_FILLCNT(x)  ((x>>11) & 0x0000000f)
#define GET_SWINF_1_INIT_DONE(x)     ((x>>15) & 0x00000001)
#define GET_SWINF_1_SYS_BUSY(x)      ((x>>17) & 0x00000001)
#define GET_SWINF_1_ERR(x)           ((x>>18) & 0x00000001)
#define GET_SWINF_2_ADDR(x)          ((x>>0)  & 0x0000ffff)
#define GET_SWINF_2_BYTECNT(x)       ((x>>16) & 0x0000000f)
#define GET_SWINF_2_SLVID(x)         ((x>>24) & 0x0000000f)
#define GET_SWINF_2_WRITE(x)         ((x>>29) & 0x00000001)
#define GET_SWINF_2_CMD(x)           ((x>>30) & 0x00000003)
#define GET_SWINF_2_WDATA_31_0(x)    ((x>>0)  & 0xffffffff)
#define GET_SWINF_2_WDATA_63_32(x)   ((x>>0)  & 0xffffffff)
#define GET_SWINF_2_WDATA_95_64(x)   ((x>>0)  & 0xffffffff)
#define GET_SWINF_2_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_SWINF_2_RDATA_31_0(x)    ((x>>0)  & 0xffffffff)
#define GET_SWINF_2_RDATA_63_32(x)   ((x>>0)  & 0xffffffff)
#define GET_SWINF_2_RDATA_95_64(x)   ((x>>0)  & 0xffffffff)
#define GET_SWINF_2_RDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_SWINF_2_VLD_CLR(x)       ((x>>0)  & 0x00000001)
#define GET_SWINF_2_EN(x)            ((x>>0)  & 0x00000001)
#define GET_SWINF_2_FSM(x)           ((x>>1)  & 0x00000007)
#define GET_SWINF_2_REQ(x)           ((x>>4)  & 0x00000001)
#define GET_SWINF_2_QUEUE_FULL(x)    ((x>>5)  & 0x00000001)
#define GET_SWINF_2_QUEUE_EMPTY(x)   ((x>>6)  & 0x00000001)
#define GET_SWINF_2_QUEUE_FREECNT(x)  ((x>>7)  & 0x0000000f)
#define GET_SWINF_2_QUEUE_FILLCNT(x)  ((x>>11) & 0x0000000f)
#define GET_SWINF_2_INIT_DONE(x)     ((x>>15) & 0x00000001)
#define GET_SWINF_2_SYS_BUSY(x)      ((x>>17) & 0x00000001)
#define GET_SWINF_2_ERR(x)           ((x>>18) & 0x00000001)
#define GET_SWINF_3_ADDR(x)          ((x>>0)  & 0x0000ffff)
#define GET_SWINF_3_BYTECNT(x)       ((x>>16) & 0x0000000f)
#define GET_SWINF_3_SLVID(x)         ((x>>24) & 0x0000000f)
#define GET_SWINF_3_WRITE(x)         ((x>>29) & 0x00000001)
#define GET_SWINF_3_CMD(x)           ((x>>30) & 0x00000003)
#define GET_SWINF_3_WDATA_31_0(x)    ((x>>0)  & 0xffffffff)
#define GET_SWINF_3_WDATA_63_32(x)   ((x>>0)  & 0xffffffff)
#define GET_SWINF_3_WDATA_95_64(x)   ((x>>0)  & 0xffffffff)
#define GET_SWINF_3_WDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_SWINF_3_RDATA_31_0(x)    ((x>>0)  & 0xffffffff)
#define GET_SWINF_3_RDATA_63_32(x)   ((x>>0)  & 0xffffffff)
#define GET_SWINF_3_RDATA_95_64(x)   ((x>>0)  & 0xffffffff)
#define GET_SWINF_3_RDATA_127_96(x)  ((x>>0)  & 0xffffffff)
#define GET_SWINF_3_VLD_CLR(x)       ((x>>0)  & 0x00000001)
#define GET_SWINF_3_EN(x)            ((x>>0)  & 0x00000001)
#define GET_SWINF_3_FSM(x)           ((x>>1)  & 0x00000007)
#define GET_SWINF_3_REQ(x)           ((x>>4)  & 0x00000001)
#define GET_SWINF_3_QUEUE_FULL(x)    ((x>>5)  & 0x00000001)
#define GET_SWINF_3_QUEUE_EMPTY(x)   ((x>>6)  & 0x00000001)
#define GET_SWINF_3_QUEUE_FREECNT(x)  ((x>>7)  & 0x0000000f)
#define GET_SWINF_3_QUEUE_FILLCNT(x)  ((x>>11) & 0x0000000f)
#define GET_SWINF_3_INIT_DONE(x)     ((x>>15) & 0x00000001)
#define GET_SWINF_3_SYS_BUSY(x)      ((x>>17) & 0x00000001)
#define GET_SWINF_3_ERR(x)           ((x>>18) & 0x00000001)

#endif //__PMIC_WRAP_REGS_HMAC__

